;Program compiled by Great Cow BASIC (0.98.02 2018-05-10)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Chip Model: MEGA328P
;Assembler header file
.INCLUDE "m328pdef.inc"

;SREG bit names (for AVR Assembler compatibility, GCBASIC uses different names)
#define C 0
#define H 5
#define I 7
#define N 2
#define S 4
#define T 6
#define V 3
#define Z 1

;********************************************************************************

;Set aside memory locations for variables
.EQU	PORTA=256

;********************************************************************************

;Register variables
.DEF	DELAYTEMP=r25
.DEF	DELAYTEMP2=r26
.DEF	SYSVALUECOPY=r21
.DEF	SYSWAITTEMPMS=r29
.DEF	SYSWAITTEMPMS_H=r30

;********************************************************************************

;Vectors
;Interrupt vectors
.ORG	0
	rjmp	BASPROGRAMSTART ;Reset
.ORG	2
	reti	;INT0
.ORG	4
	reti	;INT1
.ORG	6
	reti	;PCINT0
.ORG	8
	reti	;PCINT1
.ORG	10
	reti	;PCINT2
.ORG	12
	reti	;WDT
.ORG	14
	reti	;TIMER2_COMPA
.ORG	16
	reti	;TIMER2_COMPB
.ORG	18
	reti	;TIMER2_OVF
.ORG	20
	reti	;TIMER1_CAPT
.ORG	22
	reti	;TIMER1_COMPA
.ORG	24
	reti	;TIMER1_COMPB
.ORG	26
	reti	;TIMER1_OVF
.ORG	28
	reti	;TIMER0_COMPA
.ORG	30
	reti	;TIMER0_COMPB
.ORG	32
	reti	;TIMER0_OVF
.ORG	34
	reti	;SPI_STC
.ORG	36
	reti	;USART_RX
.ORG	38
	reti	;USART_UDRE
.ORG	40
	reti	;USART_TX
.ORG	42
	reti	;ADC
.ORG	44
	reti	;EE_READY
.ORG	46
	reti	;ANALOG_COMP
.ORG	48
	reti	;TWI
.ORG	50
	reti	;SPM_READY

;********************************************************************************

;Start of program memory page 0
.ORG	52
BASPROGRAMSTART:
;Initialise stack
	ldi	SysValueCopy,high(RAMEND)
	out	SPH, SysValueCopy
	ldi	SysValueCopy,low(RAMEND)
	out	SPL, SysValueCopy
;Call initialisation routines
	rcall	INITSYS

;Start of the main program
;''A most simple sample for GCGB and GCB.
;''------------------------------------------------------------------------
;''This program blinks the onboard LED of a microcontroller - simple.
;''
;''This sample file can be adapted to any of the supported microcontrollers
;''by simply changing the #chip creating and removing the comment.
;''
;''To make your programmer or your bootloader work, simply do the following.
;''
;''From within this IDE, select from the menu 'IDE Tools/GCB Tools/Edit Programmer Preferences' or press Ctrl-Alt-E.
;''this will show you the 'Programmer Preferences', select the 'Programmer' tab.
;''
;''For PIC:  Typically, if you are using a PICKIT2 then 'Microchip PICKit 2 CLI - Default' will work for you.
;''For AVR:  Typically, for an UNO the programmer 'Arduino UNO/328p@115200' will work - but, please edit the communication 'PORT'.
;''then, select OK to save your changes.
;''
;''For further adventures with Great Cow BASIC .... Click button "view Demos" for 1000's of sample programs.
;''
;''
;''Enjoy.
;''
;''
;''************************************************************************
;----- Configuration
;#chip 16f877a           'Make into a comment to use the AVR chipset
;----- Main body of program commences here.
;Do Forever
SysDoLoop_S1:
;Lighten Arduinos onboard LED for 100 milliseconds:
;PulseOut PortA.7, 100 ms   'PortA, PA7 LED
;Set Pin On
	lds	SysValueCopy,PORTA
	sbr	SysValueCopy,1<<7
	sts	PORTA,SysValueCopy
;Wait Time
	ldi	SysWaitTempMS,100
	ldi	SysWaitTempMS_H,0
	rcall	Delay_MS
;Set Pin Off
	lds	SysValueCopy,PORTA
	cbr	SysValueCopy,1<<7
	sts	PORTA,SysValueCopy
;Then wait 900 milliseconds after LED goes off:
;Wait 900 ms
	ldi	SysWaitTempMS,132
	ldi	SysWaitTempMS_H,3
	rcall	Delay_MS
;Loop
	rjmp	SysDoLoop_S1
SysDoLoop_E1:
BASPROGRAMEND:
	sleep
	rjmp	BASPROGRAMEND

;********************************************************************************

Delay_MS:
	inc	SysWaitTempMS_H
DMS_START:
	ldi	DELAYTEMP2,254
DMS_OUTER:
	ldi	DELAYTEMP,20
DMS_INNER:
	dec	DELAYTEMP
	brne	DMS_INNER
	dec	DELAYTEMP2
	brne	DMS_OUTER
	dec	SysWaitTempMS
	brne	DMS_START
	dec	SysWaitTempMS_H
	brne	DMS_START
	ret

;********************************************************************************

INITSYS:
;Turn off all ports
;PORTB = 0
	ldi	SysValueCopy,0
	out	PORTB,SysValueCopy
;PORTC = 0
	ldi	SysValueCopy,0
	out	PORTC,SysValueCopy
;PORTD = 0
	ldi	SysValueCopy,0
	out	PORTD,SysValueCopy
	ret

;********************************************************************************


